module OmniDataObjects
  class SourceFile
    attr_reader :name

    def initialize(name)
      @name = name
      @buffer = "/* DO NOT MODIFY: This file is autogenerated! */\n\n"
    end

    def <<(str)
      @buffer<<str
    end

    def br
      @buffer<<"\n"
    end

    def write(base_dir)
      path = base_dir ? "#{base_dir}/#{name}" : name
      # Only touch the timestamp if we've modified something
      if !File.exists?(path) || File.read(path) != @buffer
        if Options.check_only
          STDERR.print "'#{path}' has unexpected contents or doesn't exist.  The model needs to be regenerated.\n"
          exit 1
        end
        STDERR.print "Writing #{path}...\n" if Options.debug
        File.open(path, "w") do |f|
          f << @buffer
        end
      else
        STDERR.print "Skipping #{path}...\n" if Options.debug
      end
    end
  end
end
